#ifndef  SQUAREDDISPLACEMENTCALCULATOR_H
#define SQUAREDDISPLACEMENTCALCULATOR_H

#include "rumd/ExternalCalculator.h"

class Sample;
class Potential;
#include <vector>

class SquaredDisplacementCalculator : public ExternalCalculator {
public:
  SquaredDisplacementCalculator(Sample* S);
  virtual ~SquaredDisplacementCalculator();

  void GetDataInfo(std::map<std::string, bool> &active,
		   std::map<std::string, std::string> &columnIDs);
  void RemoveDataInfo(std::map<std::string, bool> &active,
			      std::map<std::string, std::string> &columnIDs);

  void GetDataValues(std::map<std::string, float> &dataValues, std::map<std::string, bool> &active);  
private:
  void Allocate(unsigned nParticles);
  void Free();
  Sample* mainSample;
  Sample* refSample;

  int3* d_sum_sq_images;
  double4* d_sum_dbl_comp;
  unsigned num_allocated;
};

__global__ void squared_displacement_kernel(unsigned nParticles, float4* im1, float4* pos1, float4* im2, float4* pos2, int3* sum_sq_images, double4* sum_dbl_comp);

#endif // SQUAREDDISPLACEMENTCALCULATOR_H
